import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, extendIgnoreDataRule, setDataFieldValue, showApprove, guid, showFiles, initQueryFilter, ShowDateTime } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class DM019ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    loadData = (id) => {
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_Device')
        extendInclude(json, 'Nav_Repair_Charge_User')
        extendInclude(json, 'Nav_Repair_User')
        extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File')
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'DM/DeviceRepair/Get',
            onComplete: (ret) => {
                if (ret) {
                    this.setState({
                        data: ret,
                    })
                }
            }
        });
    }
    render() {
        const { data } = this.state; const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} /></td>
                        <td><ExportToExcel fileName='设备设施故障报修' tableId={'tableId' + this.props.data.id} /></td>
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>设备设施故障报修</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="设备设施名称">{data.Nav_Device.NAME}</Descriptions.Item>
                            <Descriptions.Item label="规格">{data.SPEC}</Descriptions.Item>
                            <Descriptions.Item label="设备编号">{data.MACHINE_CODE}</Descriptions.Item>
                            <Descriptions.Item label="设备位置">{data.POSITION}</Descriptions.Item>
                            <Descriptions.Item label="故障描述">{data.DESCRPTION}</Descriptions.Item>
                            <Descriptions.Item label="维修紧迫性">{enums.DMRepairStatusEnum.enums[data.EMERGENCY_LEVEL_NAME]}</Descriptions.Item>
                            <Descriptions.Item label="维修负责人">{data.Nav_Repair_Charge_User.NAME}</Descriptions.Item>
                            <Descriptions.Item label="是否申请外部援助">{data.IS_HELP ? "是" : "否"}</Descriptions.Item>
                            <Descriptions.Item label="维修人员">{data.Nav_Repair_User?.NAME}</Descriptions.Item>
                            <Descriptions.Item label="附件">{showFiles(data.Nav_Files, config.picServerHost)}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
            </div>
        </div>
    }
}
export default connect(({ login, app }) => ({ login, app }))(DM019ShowPrint) 
